/*
File: TIServer.java
Date		Author		Changes
Aril 16 98 	Lukasz Beca	Created
*/

import java.net.*;
import java.lang.*;
import java.io.*;
import webwisdom.tango.threads.ComThread;
import webwisdom.tango.threads.ThreadIn;
import webwisdom.tango.threads.ThreadOut;
import webwisdom.tango.threads.DbThread;
import webwisdom.tango.threads.Timeout;
import java.util.GregorianCalendar;
import java.util.Calendar;
import java.util.Locale;
import java.util.Date;
import java.text.SimpleDateFormat;
  
public class TIServer {

  private static GregorianCalendar end;

  public static void main(String args[]) {

    int port;
    long time;
    GregorianCalendar current;
		SimpleDateFormat edf = new SimpleDateFormat();
    Date dt = null;

    FileOutputStream fout;

		 end = getEnd(); 

    dt = end.getTime();

    edf.setCalendar(end);

    current = new GregorianCalendar ();
    


    try {
	    fout = new FileOutputStream("../logs/server_log");
 		  System.setOut(new PrintStream(fout));
		   System.setErr(new PrintStream(fout));
    } catch(Exception e) {

      System.out.println("ServerApp: " + e);
      e.printStackTrace();
      fout = null;
      System.exit(1);
    }
    
    System.out.println("TangoServer: Tango Interactive Server v.1.0");
    System.out.println("TangoServer: Evaluation period ends " + dt);

    
    if (end.before(current)) {

      System.out.println("TangoServer: Evaluation period expired");
      System.out.println("TangoServer: Server terminated"); 
      return;

    } 

    
    //PrintStream pout = new PrintStream(fout);    

    try {
      port = Integer.parseInt(args[0]);

    } catch(Exception e) {

        port = 6000;
				 e.printStackTrace();	
    }
    
    Server s = new Server(port); 

    //System.out = pout;
    //System.err = pout;

    s.run();
  }
  
  
  
  
  public static GregorianCalendar getEnd() {

    int hh = 0 ^  0x38a47e38;   
    int ss = 0 ^  0xe3987a38;
    int dd = 1 ^ 0x32838ecf;
    int yy = 1998 ^ 0x2864afb4;
    int mn = 0 ^  0x7e39c39a;
    int mm = 6 ^  0x093cba45;
    
    return new GregorianCalendar(det(yy, 0x2864afb4), det(mm, 0x093cba45) , det(dd, 0x32838ecf), det(hh, 0x38a47e38), det(mn, 0x7e39c39a) , det(ss, 0xe3987a38));

  }

  public static int det(int n1, int n2) {

    return n1 ^ n2;
  }
}

class Server {
 
  private int port;
  ComThread c;
  DbThread d;
  Timeout t;

  public Server(int p) {

    port = p;
  }

  public void run() {

    Socket conn;    
    boolean exit;
    GregorianCalendar current, end;
   
   	exit = false;
    end = TIServer.getEnd();
   
    try {
      
      ServerSocket socket = new ServerSocket(port);

      System.out.println("Server started on port " + port);
   
       c = new ComThread();
       d = new DbThread();
       t = new Timeout(5 * 60 * 1000, c);

			 System.out.println("Server: clean exit");	
			
       c.start();   
       d.start();
        
      do {

	  			 conn = socket.accept();
				 current = new GregorianCalendar();
        if (end.before(current)) {
            
          exit = true;
          System.out.println("TangoServer: Evaluation period expired");
          System.out.println("TangoServer: Server terminated");      
           
        } else {				 
				 
      	  handleConnection(conn);
			   }
	
      } while (!exit);
   
    } catch(Exception e) {

       System.out.println("Err: " + e);
				e.printStackTrace();
    }
  }

  private void handleConnection(Socket sock) {
   
    ThreadIn i;
    ThreadOut o;
      
    System.out.println("Connection accepted, starting threads ......");
    o = new ThreadOut(sock);   
    i = new ThreadIn(c, d, o, sock, t);
   
  }      
}




